%
%  env_fds.m  ver 1.1  December 6, 2013
%
function[fds_ref]=env_fds(interp_psdin,nnn,fn,dam,bex,T)
%
n_dam=length(dam);
n_bex=length(bex);
%
%
fds_ref=zeros(n_dam,n_bex,nnn);
%
for ijk=1:n_dam
%        
        for i=1:nnn
%
            apsd=zeros(nnn,1);
%
            for j=1:nnn
%		
              % fn(i) is the natural frequency
			  % fn(j) is the forcing frequency
%
	          rho=fn(j)/fn(i);
%			  
			  tdr=2.*dam(ijk)*rho;
%
			  tden=((1.-(rho^2))^2)+(tdr^2);
			  tnum=1.+(tdr^2);
%
			  trans=tnum/tden;
%
              apsd(j)=trans*interp_psdin(j);
%	  
            end  % forcing freq
%
            [m0,grms]=cm0(apsd,fn,nnn);
                 [m1]=cm1(apsd,fn,nnn);
                 [m2]=cm2(apsd,fn,nnn);
                 [m4]=cm4(apsd,fn,nnn);     
%
%%            out1=sprintf(' %8.4g %8.4g %8.4g %8.4g %8.4g ',grms,m0,m1,m2,m4);
%%            disp(out1);
%
            EP=sqrt(m4/m2);
            x=(m1/m0)*sqrt(m2/m4);
            gamma=m2/(sqrt(m0*m4));
            D1=2*(x-gamma^2)/(1+gamma^2);
            R=(gamma-x-D1^2)/(1-gamma-D1+D1^2);
            D2=(1-gamma-D1+D1^2)/(1-R);
            D3=1-D1-D2;
            Q=1.25*(gamma-D3-D2*R)/D1;                     
%
            maxS=8*grms;
%
            ds=maxS/400;
%
            n=round(maxS/ds);
%
            N=zeros(n,1);
            S=zeros(n,1);
%
            for j=1:n
                S(j)=(j-1)*ds;
                Z=S(j)/(2*sqrt(m0));
%    
                t1=(D1/Q)*exp(-Z/Q);
                a=-Z^2;
                b=2*R^2;
%    
                t2=(D2*Z/R^2)*exp(a/b);
                t3=D3*Z*exp(-Z^2/2);
%    
                pn=t1+t2+t3;
                pd=2*sqrt(m0);
                p=pn/pd;
%    
                N(j)=p;
            end
            N=N*EP*T;
%
            area=0;
            cumu=zeros(n,1);
            for j=1:n
                area=area+N(j)*ds;
                cumu(j)=area;
%%                out1=sprintf(' %8.4g  %8.4g ',S(j),cumu(j));
%%                disp(out1);
            end
%
            num=ceil(cumu(n));
%%            out1=sprintf('  EP=%8.4g T=%8.4g  num=%d ',EP,T,num);
%%            disp(out1);
%
            xq=zeros(num,1);
            for j=1:num
                xq(j)=j;    
            end
%            
%%            out1=sprintf(' minxq=%8.4g  maxxq=%8.4g ',min(xq),max(xq));
%%            disp(out1);
%            
%%            out1=sprintf(' minS=%8.4g  maxS=%8.4g ',min(S),max(S));
%%            disp(out1);            
%            
%%            disp('xq S cumu vq1');
%%            length(xq)
%%            length(S)
%%            length(cumu)
%
            vq1 = interp1(cumu,S,xq);
%%            length(vq1) 
%
            clear A;
            clear range;
            clear amp;
%
%%            vq1 
            A=[xq vq1];
%%            size(A)
            A(any(isnan(A),2),:)=[];
            range=A(:,2);
            range=sort(range,'descend');
            amp=range/2;
%
%%            size(A)
%%            out1=sprintf(' max range=%8.4g  ',max(range));
%%            disp(out1);
%
            for nv=1:n_bex
                d=0;
                for j=1:length(amp)
                    d=d+amp(j)^bex(nv);
                end
                fds_ref(ijk,nv,i)=d;
%
%%                out1=sprintf(' grms=%8.4g  la=%d d=%8.4g  ',grms,length(amp),d);
%%                disp(out1);
%
            end
%
        end % fn
%  
end  % dam